/**************************************************************************
 * Voraca 0.95 (VOlume RAy-CAster)
 **************************************************************************
 * Copyright (c) 2014, Raphael Philipp Menges
 *
 * Permission to use, copy, modify, and/or distribute this software for any 
 * purpose with or without fee is hereby granted, provided that the above 
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES 
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR 
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN 
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF 
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 **************************************************************************/

/*
 * Primitives
 *--------------
 * Simple OpenGL primitives.
 *
 */

#ifndef PRIMITIVES_H_
#define PRIMITIVES_H_

#include "GL/glew.h"
#include "GLFW/glfw3.h"
#include "glm/glm.hpp"

namespace primitives
{
	/** Cube from 0 to 1 */
	static GLfloat cube[] = {
		-0.5f,-0.5f,-0.5f, -0.5f,0.5f,-0.5f, 0.5f,0.5f,-0.5f, 0.5f,-0.5f,-0.5f,
		-0.5f,-0.5f,0.5f, 0.5f,-0.5f,0.5f, 0.5f,0.5f,0.5f, -0.5f,0.5f,0.5f,
		-0.5f,0.5f,-0.5f, -0.5f,0.5f,0.5f, 0.5f,0.5f,0.5f, 0.5f,0.5f,-0.5f,
		-0.5f,-0.5f,-0.5f, 0.5f,-0.5f,-0.5f, 0.5f,-0.5f,0.5f, -0.5f,-0.5f,0.5f,
		0.5f,-0.5f,-0.5f, 0.5f,0.5f,-0.5f, 0.5f,0.5f,0.5f, 0.5f,-0.5f,0.5f,
		-0.5f,-0.5f,-0.5f, -0.5f,-0.5f,0.5f, -0.5f,0.5f,0.5f, -0.5f,0.5f,-0.5f
	};

	// Quad for screen filling
	static GLfloat screenFillQuad[] = {
		-1,-1,0, 1,-1,0, 1,1,0, -1,1,0
	};

	// Quad
	static GLfloat quad[] = {
		0,0,0, 1,0,0, 1,1,0, 0,1,0
	};

	// Crosshair
	static GLfloat crosshair[] = {
		-0.75f,-0.1f,0, -0.25f,-0.1f,0, -0.25f,0.1f,0, -0.75f,0.1f,0,
		0.25f,-0.1f,0, 0.75f,-0.1f,0, 0.75f,0.1f,0, 0.25f,0.1f,0,
		-0.1f,0.25f,0, 0.1f,0.25f,0, 0.1f,0.75f,0, -0.1f,0.75f,0,
		-0.1f,-0.25f,0, -0.1f,-0.75f,0, 0.1f,-0.75f,0, 0.1f,-0.25f,0
	};

	// Line
	static GLfloat line[] = {
		0,0,0, 1,0,0
	};

	// Quad of lines
	static GLfloat lineQuad[] = {
		0,0,0, 1,0,0, 1,1,0, 0,1,0, 0,0,0
	};

	// Cube of lines
	static GLfloat lineCube[] = {
		-0.5f,-0.5f,-0.5f, 0.5f,-0.5f,-0.5f, -0.5f,-0.5f,0.5f, 0.5f,-0.5f,0.5f,
		-0.5f,-0.5f,-0.5f, -0.5f,-0.5f,0.5f, 0.5f,-0.5f,-0.5f, 0.5f,-0.5f,0.5f,

		-0.5f,0.5f,-0.5f, 0.5f,0.5f,-0.5f, -0.5f,0.5f,0.5f, 0.5f,0.5f,0.5f,
		-0.5f,0.5f,-0.5f, -0.5f,0.5f,0.5f, 0.5f,0.5f,-0.5f, 0.5f,0.5f,0.5f,

		-0.5f,-0.5f,-0.5f, -0.5f,0.5f,-0.5f, 0.5f,-0.5f,-0.5f, 0.5f,0.5f,-0.5f,
		-0.5f,-0.5f,0.5f, -0.5f,0.5f,0.5f, 0.5f,-0.5f,0.5f, 0.5f,0.5f,0.5f
	};
}

#endif